$Compile Exe
$Resource "HTTP.PBR"
$Include "WIN32API.INC"
$Include "WSOCK32.INC"

%WM_TRAYICON = %WM_USER + 400
%WM_PAGEREQUEST = %WM_USER + 401

%PORTNUM=80

Declare Function SocketThread ( ByVal hsocket As Long ) As Long
Declare Function MonitorThread( ByVal hsocket As Long ) As Long
Declare Sub WriteErrorPage
Declare Function Process$(HTML$)

Global hInst As Long


Function WinMain (ByVal CurInst As Long, _
                  ByVal PrvInst As Long, _
                  CmdLine As Asciiz Ptr, _
                  ByVal CmdShow As Long) Export As Long

  Global fnum As Long
  Global flags As Long
  Global NumberOfThreads As Integer
  Global BADCHARS As String
  Global Quiet As Integer ' if true shuts up threads from announcing status
  Dim IdThread(9999) As Global Long 'array to store thread handles
  Dim TimeThread(9999) As Global Long ' array to store start time of thread
  Dim CRLFThread(9999) As Global Byte ' array to store thread output characteristics
  Dim Mon As Global Integer
  Dim Dummy As Long
  Dim hMonitor As Long

  BADCHARS = Chr$( 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26 )
  Dummy = 0
  Thread Create MonitorThread( Dummy ) To hMONITOR

  ' ** Initialize our main dialog
  hInst = CurInst
  DialogBox hInst, ByVal 100&, %HWND_DESKTOP, CodePtr(DialogProc)


End Function

Function DialogProc(ByVal hDlg As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Local hSocket     As Long
  Static hMenu As Long
  Static ti    As NOTIFYICONDATA
  Static p     As POINTAPI


  Select Case wMsg

   Case %WM_PAGEREQUEST
      Select Case LoWrd(lParam)

        Case %FD_ACCEPT

          hSocket=FreeFile
          Tcp Accept fnum As hSocket

          Thread Create SocketThread( hSocket ) To idthread( hSocket )
          timethread(hSocket)=Timer
          'TCP NOTIFY hSocket, RECV CLOSE TO hDlg AS %TCP_CONNECT

        Case %FD_READ
          'IF hSocket <> %INVALID_SOCKET THEN
          '  TCP RECV hSocket, 1024, buffer
          '  TCP SEND hEchoSock, buffer
          '  'LogEvent CHR$(34) + Buffer + CHR$(34)
          'ELSE
          '  'LogEvent "* FD_READ Error!"
          'END IF
      End Select
    Case %WM_INITDIALOG
      ' ** Get Menu Handle
      hMenu = GetSubMenu(LoadMenu(hInst, "POPUPMENU"), 0)

      ' ** Add tray icon
      ti.cbSize           = SizeOf(ti)
      ti.hWnd             = hDlg
      ti.uID              = hInst
      ti.uFlags           = %NIF_ICON Or %NIF_MESSAGE Or %NIF_TIP
      ti.uCallbackMessage = %WM_TRAYICON
      ti.hIcon            = LoadIcon(hInst, "PBWEB")
      ti.szTip            = "HTTP Server"
      Shell_NotifyIcon %NIM_ADD, ti
      DestroyIcon ti.hIcon

      fnum = FreeFile
      Tcp Open Server Port %PORTNUM As #fnum
      If Err Then
        ' open the server on port 81 if a server is already running on 80
        Tcp Open Server Port %PORTNUM+1 As #fnum
      End If
      Tcp Notify #fnum, Accept Connect To hDlg As %WM_PAGEREQUEST

      Function = 1

    Case %WM_TRAYICON

      Select Case LoWrd(lParam)

        ' ** Left button press

        Case %WM_LBUTTONDOWN
          If IsWindowVisible(hDlg) = %FALSE Then
            ShowWindow hDlg, %SW_SHOW
          End If

        ' ** Right button press
        Case %WM_RBUTTONDOWN
          If IsWindowVisible(hDlg) = %FALSE Then
            SetForegroundWindow hDlg
            GetCursorPos p
            TrackPopupMenu hMenu, 0, p.x, p.y, 0, hDlg, ByVal %NULL
            Postmessage hDlg, %WM_NULL, 0, 0
          End If

      End Select

    Case %WM_DESTROY
      ' ** Remove the HTTP icon if the application is closed
      Shell_NotifyIcon %NIM_DELETE, ti

    Case %WM_COMMAND

      Select Case LoWrd(wParam)

        Case 101
            ' ** change tray icon
           ti.hIcon=LoadIcon(hInst, "PBWEB" )
           Shell_NotifyIcon %NIM_MODIFY, ti
           DestroyIcon ti.hIcon
           ShowWindow hDlg, %SW_HIDE
           Function = 1

        Case %IDOK
          ' ** Display the about box
          DialogBox hInst, ByVal 101&, %HWND_DESKTOP, CodePtr(AboutProc)

        Case %IDCANCEL
          ' ** Make sure they want to exit
          If MessageBox(hDlg,"Shutdown web server and remove icon from taskbar?" , "HTTP Server", %MB_ICONEXCLAMATION Or %MB_OKCANCEL) = %IDOK Then
            EndDialog hDlg, 0
            Function = 1
          End If

      End Select

    Case %WM_SYSCOMMAND

      ' ** If either the minimize or close buttons are pressed, hide the
      '    window so it doesn't appear in the task bar.

      Select Case LoWrd(wParam)

        Case %SC_MINIMIZE
          ShowWindow hDlg, %SW_HIDE
          Function = 1
          Exit Function

        Case %SC_CLOSE
          ShowWindow hDlg, %SW_HIDE
          Function = 1
          Exit Function

      End Select

  End Select

End Function

Function AboutProc(ByVal hDlg As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

  Select Case wMsg

    Case %WM_INITDIALOG

      Function = 1

    Case %WM_COMMAND

      If LoWrd(wParam) = %IDOK Then
        EndDialog hDlg, 0
        Function = 1
      End If

  End Select

End Function


Function SocketThread( ByVal hsocket As Long ) As Long
  ' This is a distinct thread for each client
  ' this function receives data and writes it
  ' into the IN directory


  Dim Buf As String
  Dim ThisThread As Integer
  Dim Finished As Integer
  Dim FF As Integer
  Dim a$, Cmd$, InBuffer$, Fi$, Ext$, Content$, HTML$, HEADER$

  Do Until TIMEThread(hSocket) < 0
    Sleep 100 'release CPU time

    Tcp Recv hSocket,1024, a$
    If Len( a$ ) > 0 Then
      TIMEThread(hSocket) = Timer

      ' Add input data to buffer
      a$ = Remove$( a$, Any BADCHARS )
      Replace Chr$(13,10) With Chr$(13) In a$ ' filter out crlf pairs, make them cr
      InBuffer$ = InBuffer$ + a$

      Do While InStr( InBuffer$, Chr$( 13 ))
        Sleep 1 'release CPU time
        InBuffer$ = Remove$( InBuffer$, Any BADCHARS )
        Cmd$ = Left$( InBuffer$, InStr( InBuffer$, Chr$( 13 )) - 1 )
        InBuffer$ = Mid$( InBuffer$, InStr( InBuffer$, Chr$( 13 )) + 1 )

        If Left$(Cmd$,3)="GET" Then '..................................GET an object by name
          fi$ = Mid$(Cmd$,5) '...............GET /page.htm HTTP/1.x
          If InStr(Cmd$," ") Then
            fi$ = Left$(fi$,InStr(fi$," ")-1)
          End If
          fi$ = LTrim$(RTrim$(fi$))
          If fi$ = "/" Or fi$ = "\" Or fi$ = "" Then fi$ = "default.htm"
          Replace "/" With "\" In fi$ ' ........................change unix style slashes
          If Left$(fi$,1)="\" Then fi$ = Mid$(fi$,2) ' .............use current dir as root
          If Right$(fi$,1)="\" Then fi$ = fi$ + "default.htm"
          ' Should actually do real http error headers here, but this is good enough
          ' if page is not found then use "error.htm" as custom error msg.  Create if not exist
          If InStr(fi$,".")=0 Then
            fi$ = fi$ + ".htm"
          End If  '.........................default to .htm extension (how nice!)


          If Dir$(fi$) = "" Then fi$ = "error.htm" : If Dir$("error.htm")="" Then WriteErrorPage
          'STDOUT "sending " + fi$
          ' establish filename for data type.  All files are binary files (even html files)
          ext$ = Mid$(fi$,InStr(fi$,".")+1)

          Select Case LCase$(ext$)
            Case "htm", "html", "bas", "txt"
              Content$ = "text/html"
            Case "jpg","jpeg"
              Content$ = "image/jpeg"
            Case "gif"
              Content$ = "image/gif"
            Case "exe", "com", "bat", "cgi", "cmd", "bin"
              Content$ = "text/html" ' CGI support (not done)
              ' need to shell fi$ with < stdin > stdout and echo back output
              Shell fi$ + " > temp.htm" ' a kludge for testing
              fi$ = "temp.htm" ' show output of shell cmd
            Case Else
              Content$ = "application/octet-stream"
          End Select
          'STDOUT ext$ + " is " + Content$
        End If ' IF GET

        If Cmd$="" Then '.............CRLF on a line by itself  indicates header is over
          ff = FreeFile
          Open fi$ For Binary Shared As #ff '..........read the page from disk into HTML$
          Get$ #ff, Lof(FF), HTML$

          Close #ff

          HTML$ = Process$(HTML$) '............... Do any custom stuff to the web page

          ' ...................................... create the header for this page
          HEADER$ = "HTTP/1.0 200 OK" + $CrLf
          HEADER$ = HEADER$ + "Server: PBHTTP 1.1" + $CrLf
          HEADER$ = HEADER$ + "Content-Type: " + Content$ + $CrLf
          HEADER$ = HEADER$ + "Accept-Ranges: bytes" + $CrLf
          HEADER$ = HEADER$ + "Content-Length: " + LTrim$(Str$(Len(HTML$))) + $CrLf
          HEADER$ = HEADER$ + $CrLf

          ' Show Time ! ! !
          TIMEThread(hSocket) = Timer '...............update activity timer
          buf = HEADER$ + HTML$
          If Len( Buf ) > 0 Then
            Tcp Print #hSocket, Buf;
            If Mon = hSocket Then '.............monitor activity on a thread
            End If
          End If

          finished = -1
          Exit Loop
        End If ' Header is over

      Loop ' In buffer has chr(13)
    End If

  Loop While Not finished


  Tcp Close #hSocket
  TIMEThread(hSocket)=99999 ' tell monitorthread to kill us
End Function



Function MonitorThread( ByVal hsocket As Long ) As Long
  ' every 10 seconds, check all of the threads.  if any are
  ' over 60 seconds old, tell them to die.  If any threads
  ' have responded to the death instruction, close them.
  Sleep 500
  Dim R&, Sts&
  Dim y%

  Do
    Sleep 10000

    For y% = 1 To 9999

      If idThread(y%) Then
        sts& = 0
'        THREAD STATUS idThread(y%) TO sts&
        If TIMEThread(y%)=-1 Then
          ' thread has been told to die
        ElseIf TIMEThread(y%) = 99999 Then ' close the dead thread
          Sleep 1000
         Thread Close idThread(y%) To r&
'         if not quiet then
'           stdout "Closed thread " + hex$(y%)+" result = " + str$(r&)
'         end if
          TIMEThread(y%)=0
          idThread(y%)=0
        Else
          ' expire the thread
          If Timer - timethread(y%) > 15 Then
            TIMEThread(y%) = -1
          End If
        End If
      End If

    Next y%

  Loop

End Function

Sub WriteErrorPage
  Dim ff As Integer
  ff = FreeFile
  Open "Error.htm" For Output As #ff
  Print #ff, "<HTML><HEAD><TITLE>PBHTTP ERROR</TITLE></HEAD><BODY>URL NOT FOUND!</BODY></HTML>"
  Close #ff
End Sub

Function Process$(HTML$)

  ' do anything to the web page that floats your boat before sending it.  Invent your own
  ' server side script language, for example.  Add INCLUDE files.  Filter cuss words.

  ' ..or, for example, some simple substitutions in the page being displayed
  Replace "%TIME%" With Time$ In HTML$
  Replace "%DATE%" With Date$ In HTML$
  Replace "Erik Olson" With "Helpless Erik Olson the Meek and Small" In HTML$

  Function = HTML$

End Function
