/*****************************************************************************\
 *                                                                           *
 *  Resource include file for PB/DLL                                         *
 *  Copyright (c) 1996 PowerBASIC, Inc.  All Rights Reserved.                *
 *                                                                           *
\*****************************************************************************/

/* File attributes */
#define ReadOnly                        0x000001
#define Hidden                          0x000010
#define System                          0x000100
#define vLabel                          0x001000
#define SubDir                          0x010000
#define Archive                         0x100000

/* Common RGB Colors */
#define Black                           0x000000
#define Blue                            0xFF0000
#define Green                           0x00FF00
#define Cyan                            0xFFFF00
#define Red                             0x0000FF
#define Magenta                         0xFF00FF
#define Yellow                          0x00FFFF
#define White                           0xFFFFFF

#define NULL                            0x0000
#define FALSE                           0
#define TRUE                            -1

/* OpenFile() Flags */
#define OF_READ                         0x0
#define OF_WRITE                        0x1
#define OF_READWRITE                    0x2
#define OF_SHARE_COMPAT                 0x0
#define OF_SHARE_EXCLUSIVE              0x10
#define OF_SHARE_DENY_WRITE             0x20
#define OF_SHARE_DENY_READ              0x30
#define OF_SHARE_DENY_NONE              0x40
#define OF_PARSE                        0x100
#define OF_DELETE                       0x200
#define OF_VERIFY                       0x400
#define OF_CANCEL                       0x800
#define OF_CREATE                       0x1000
#define OF_PROMPT                       0x2000
#define OF_EXIST                        0x4000
#define OF_REOPEN                       0x8000

/* GetTempFileName() Flags */
#define TF_FORCEDRIVE                   0x80

/* llseek Flags */
#define SEEK_SET                        0
#define SEEK_CUR                        1
#define SEEK_END                        2

/* GetDriveTYPE return values
#define DRIVE_UNKNOWN                   0
#define DRIVE_NOROOT                    1
#define DRIVE_REMOVABLE                 2
#define DRIVE_FIXED                     3
#define DRIVE_REMOTE                    4
#define DRIVE_CDROM                     5       /* Win32 */
#define DRIVE_RAMDISK                   6       /* Win32 */

/* Global Memory Flags */
#define GMEM_FIXED                      0x0
#define GMEM_MOVEABLE                   0x2
#define GMEM_NOCOMPACT                  0x10
#define GMEM_NODISCARD                  0x20
#define GMEM_ZEROINIT                   0x40
#define GMEM_MODIFY                     0x80
#define GMEM_DISCARDABLE                0x100
#define GMEM_NOT_BANKED                 0x1000
#define GMEM_SHARE                      0x2000
#define GMEM_DDESHARE                   0x2000
#define GMEM_NOTIFY                     0x4000
#define GMEM_LOWER                      GMEM_NOT_BANKED

#define GHND                            GMEM_MOVEABLE | GMEM_ZEROINIT
#define GPTR                            GMEM_FIXED | GMEM_ZEROINIT

/* Flags returned by GlobalFlags (in addition to GMEM_DISCARDABLE) */
#define GMEM_DISCARDED                  0x4000
#define GMEM_LOCKCOUNT                  0xFF

/* Local Memory Flags */
#define LMEM_FIXED                      0x0
#define LMEM_MOVEABLE                   0x2
#define LMEM_NOCOMPACT                  0x10
#define LMEM_NODISCARD                  0x20
#define LMEM_ZEROINIT                   0x40
#define LMEM_MODIFY                     0x80
#define LMEM_DISCARDABLE                0xF00

#define LHND                            LMEM_MOVEABLE | LMEM_ZEROINIT
#define LPTR                            LMEM_FIXED | LMEM_ZEROINIT

#define NONZEROLHND                     LMEM_MOVEABLE
#define NONZEROLPTR                     LMEM_FIXED

#define LNOTIFY_OUTOFMEM                0
#define LNOTIFY_MOVE                    1
#define LNOTIFY_DISCARD                 2

#define SEM_FAILCRITICALERRORS          0x0001
#define SEM_NOGPFAULTERRORBOX           0x0002
#define SEM_NOOPENFILEERRORBOX          0x8000

/* Flags returned by LocalFlags (in addition to LMEM_DISCARDABLE) */
#define LMEM_DISCARDED                  0x4000
#define LMEM_LOCKCOUNT                  0xFF

/* Predefined Resource TYPEs */
#define RT_CURSOR                       1
#define RT_BITMAP                       2
#define RT_ICON                         3
#define RT_MENU                         4
#define RT_DIALOG                       5
#define RT_STRING                       6
#define RT_FONTDIR                      7
#define RT_FONT                         8
#define RT_ACCELERATOR                  9
#define RT_RCDATA                       10

#define WF_PMODE                        0x1
#define WF_CPU286                       0x2
#define WF_CPU386                       0x4
#define WF_CPU486                       0x8
#define WF_STANDARD                     0x10
#define WF_WIN286                       0x10
#define WF_ENHANCED                     0x20
#define WF_WIN386                       0x20
#define WF_CPU086                       0x40
#define WF_CPU186                       0x80
#define WF_LARGEFRAME                   0x100
#define WF_SMALLFRAME                   0x200
#define WF_80x87                        0x400

/* WEP fSystemExit flag values */
#define WEP_SYSTEM_EXIT                 1
#define WEP_FREE_DLL                    0

/* OEM Resource Ordinal Numbers */
#define OBM_CLOSE                       32754
#define OBM_UPARROW                     32753
#define OBM_DNARROW                     32752
#define OBM_RGARROW                     32751
#define OBM_LFARROW                     32750
#define OBM_REDUCE                      32749
#define OBM_ZOOM                        32748
#define OBM_RESTORE                     32747
#define OBM_REDUCED                     32746
#define OBM_ZOOMD                       32745
#define OBM_RESTORED                    32744
#define OBM_UPARROWD                    32743
#define OBM_DNARROWD                    32742
#define OBM_RGARROWD                    32741
#define OBM_LFARROWD                    32740
#define OBM_MNARROW                     32739
#define OBM_COMBO                       32738

#define OBM_OLD_CLOSE                   32767
#define OBM_SIZE                        32766
#define OBM_OLD_UPARROW                 32765
#define OBM_OLD_DNARROW                 32764
#define OBM_OLD_RGARROW                 32763
#define OBM_OLD_LFARROW                 32762
#define OBM_BTSIZE                      32761
#define OBM_CHECK                       32760
#define OBM_CHECKBOXES                  32759
#define OBM_BTNCORNERS                  32758
#define OBM_OLD_REDUCE                  32757
#define OBM_OLD_ZOOM                    32756
#define OBM_OLD_RESTORE                 32755

#define OCR_NORMAL                      32512
#define OCR_IBEAM                       32513
#define OCR_WAIT                        32514
#define OCR_CROSS                       32515
#define OCR_UP                          32516
#define OCR_SIZE                        32640
#define OCR_ICON                        32641
#define OCR_SIZENWSE                    32642
#define OCR_SIZENESW                    32643
#define OCR_SIZEWE                      32644
#define OCR_SIZENS                      32645
#define OCR_SIZEALL                     32646
#define OCR_ICOCUR                      32647

#define OIC_SAMPLE                      32512
#define OIC_HAND                        32513
#define OIC_QUES                        32514
#define OIC_BANG                        32515
#define OIC_NOTE                        32516

/* Binary raster ops */
#define R2_BLACK                        1
#define R2_NOTMERGEPEN                  2
#define R2_MASKNOTPEN                   3
#define R2_NOTCOPYPEN                   4
#define R2_MASKPENNOT                   5
#define R2_NOT                          6
#define R2_XORPEN                       7
#define R2_NOTMASKPEN                   8
#define R2_MASKPEN                      9
#define R2_NOTXORPEN                    10
#define R2_NOP                          11
#define R2_MERGENOTPEN                  12
#define R2_COPYPEN                      13
#define R2_MERGEPENNOT                  14
#define R2_MERGEPEN                     15
#define R2_WHITE                        16

/*  Ternary raster operations */
#define SRCCOPY                         0xCC0020
#define SRCPAINT                        0xEE0086
#define SRCAND                          0x8800C6
#define SRCINVERT                       0x660046
#define SRCERASE                        0x440328
#define NOTSRCCOPY                      0x330008
#define NOTSRCERASE                     0x1100A6
#define MERGECOPY                       0xC000CA
#define MERGEPAINT                      0xBB0226
#define PATCOPY                         0xF00021
#define PATPAINT                        0xFB0A09
#define PATINVERT                       0x5A0049
#define DSTINVERT                       0x550009
#define BLACKNESS                       0x42
#define WHITENESS                       0xFF0062

/* StretchBlt() Modes */
#define BLACKONWHITE                    1
#define WHITEONBLACK                    2
#define COLORONCOLOR                    3

/* PolyFill() Modes */
#define ALTERNATE                       1
#define WINDING                         2

/* Text Alignment Options */
#define TA_NOUPDATECP                   0
#define TA_UPDATECP                     1

#define TA_LEFT                         0
#define TA_RIGHT                        2
#define TA_CENTER                       6

#define TA_TOP                          0
#define TA_BOTTOM                       8
#define TA_BASELINE                     24

#define ETO_GRAYED                      1
#define ETO_OPAQUE                      2
#define ETO_CLIPPED                     4

#define ASPECT_FILTERING                0x1

/* Metafile FUNCTIONs */
#define META_SETBKCOLOR                 0x201
#define META_SETBKMODE                  0x102
#define META_SETMAPMODE                 0x103
#define META_SETROP2                    0x104
#define META_SETRELABS                  0x105
#define META_SETPOLYFILLMODE            0x106
#define META_SETSTRETCHBLTMODE          0x107
#define META_SETTEXTCHAREXTRA           0x108
#define META_SETTEXTCOLOR               0x209
#define META_SETTEXTJUSTIFICATION       0x20A
#define META_SETWINDOWORG               0x20B
#define META_SETWINDOWEXT               0x20C
#define META_SETVIEWPORTORG             0x20D
#define META_SETVIEWPORTEXT             0x20E
#define META_OFFSETWINDOWORG            0x20F
#define META_SCALEWINDOWEXT             0x400
#define META_OFFSETVIEWPORTORG          0x211
#define META_SCALEVIEWPORTEXT           0x412
#define META_LINETO                     0x213
#define META_MOVETO                     0x214
#define META_EXCLUDECLIPRECT            0x415
#define META_INTERSECTCLIPRECT          0x416
#define META_ARC                        0x817
#define META_ELLIPSE                    0x418
#define META_FLOODFILL                  0x419
#define META_PIE                        0x81A
#define META_RECTANGLE                  0x41B
#define META_ROUNDRECT                  0x61C
#define META_PATBLT                     0x61D
#define META_SAVEDC                     0x1E
#define META_SETPIXEL                   0x41F
#define META_OFFSETCLIPRGN              0x220
#define META_TEXTOUT                    0x521
#define META_BITBLT                     0x922
#define META_STRETCHBLT                 0xB23
#define META_POLYGON                    0x324
#define META_POLYLINE                   0x325
#define META_ESCAPE                     0x626
#define META_RESTOREDC                  0x127
#define META_FILLREGION                 0x228
#define META_FRAMEREGION                0x429
#define META_INVERTREGION               0x12A
#define META_PAINTREGION                0x12B
#define META_SELECTCLIPREGION           0x12C
#define META_SELECTOBJECT               0x12D
#define META_SETTEXTALIGN               0x12E
#define META_DRAWTEXT                   0x62F

#define META_CHORD                      0x830
#define META_SETMAPPERFLAGS             0x231
#define META_EXTTEXTOUT                 0xA32
#define META_SETDIBTODEV                0xD33
#define META_SELECTPALETTE              0x234
#define META_REALIZEPALETTE             0x35
#define META_ANIMATEPALETTE             0x436
#define META_SETPALENTRIES              0x37
#define META_POLYPOLYGON                0x538
#define META_RESIZEPALETTE              0x139

#define META_DIBBITBLT                  0x940
#define META_DIBSTRETCHBLT              0xB41
#define META_DIBCREATEPATTERNBRUSH      0x142
#define META_STRETCHDIB                 0xF43

#define META_DELETEOBJECT               0x1F0

#define META_CREATEPALETTE              0xF7
#define META_CREATEBRUSH                0xF8
#define META_CREATEPATTERNBRUSH         0x1F9
#define META_CREATEPENINDIRECT          0x2FA
#define META_CREATEFONTINDIRECT         0x2FB
#define META_CREATEBRUSHINDIRECT        0x2FC
#define META_CREATEBITMAPINDIRECT       0x2FD
#define META_CREATEBITMAP               0x6FE
#define META_CREATEREGION               0x6FF

/* GDI Escapes */
#define NEWFRAME                         1
#define NEXTBAND                         3
#define SETCOLORTABLE                    4
#define GETCOLORTABLE                    5
#define FLUSHOUTPUT                      6
#define DRAFTMODE                        7
#define QUERYESCSUPPORT                  8
#define SETABORTPROC                     9
#define GETPHYSPAGESIZE                 12
#define GETPRINTINGOFFSET               13
#define GETSCALINGFACTOR                14
#define MFCOMMENT                       15
#define GETPENWIDTH                     16
#define SETCOPYCOUNT                    17
#define SELECTPAPERSOURCE               18
#define DEVICEDATA                      19
#define PASSTHROUGH                     19
#define GETTECHNOLGY                    20
#define GETTECHNOLOGY                   20
#define SETENDCAP                       21
#define SETLINEJOIN                     22
#define SETMITERLIMIT                   23
#define BANDINFO24
#define DRAWPATTERNRECT                 25
#define GETVECTORPENSIZE                26
#define GETVECTORBRUSHSIZE              27
#define ENABLEDUPLEX                    28
#define GETSETPAPERBINS                 29
#define GETSETPRINTORIENT               30
#define ENUMPAPERBINS                   31
#define SETDIBSCALING                   32
#define EPSPRINTING                     33
#define ENUMPAPERMETRICS                34
#define GETSETPAPERMETRICS              35
#define POSTSCRIPT_DATA                 37
#define POSTSCRIPT_IGNORE               38
#define GETEXTENDEDTEXTMETRICS          256
#define GETEXTENTTABLE                  257
#define GETPAIRKERNTABLE                258
#define GETTRACKKERNTABLE               259
#define EXTTEXTOUTAPI                   512
#define ENABLERELATIVEWIDTHS            768
#define ENABLEPAIRKERNING               769
#define SETKERNTRACK                    770
#define SETALLJUSTVALUES                771
#define SETCHARSET                      772

#define STRETCHBLTAPI                   2048
#define BEGIN_PATH                      4096
#define CLIP_TO_PATH                    4097
#define END_PATH                        4098
#define EXT_DEVICE_CAPS                 4099
#define RESTORE_CTM                     4100
#define SAVE_CTM4101
#define SET_ARC_DIRECTION               4102
#define SET_BACKGROUND_COLOR            4103
#define SET_POLY_MODE                   4104
#define SET_SCREEN_ANGLE                4105
#define SET_SPREAD                      4106
#define TRANSFORM_CTM                   4107
#define SET_CLIP_BOX                    4108
#define SET_BOUNDS                      4109
#define SET_MIRROR_MODE                 4110

/* Spooler Error Codes */
#define SP_NOTREPORTED                  0x4000
#define SP_ERROR                        -1
#define SP_APPABORT                     -2
#define SP_USERABORT                    -3
#define SP_OUTOFDISK                    -4
#define SP_OUTOFMEMORY                  -5

#define PR_JOBSTATUS                    0x0

/* constants for the biCompression field */
#define BI_RGB                          0
#define BI_RLE8                         1
#define BI_RLE4                         2

/* Logical Font */
#define LF_FACESIZE                     32

#define SIMULATED_FONTTYPE              0x8000
#define PRINTER_FONTTYPE                0x4000
#define SCREEN_FONTTYPE                 0x2000
#define BOLD_FONTTYPE                   0x0100
#define ITALIC_FONTTYPE                 0x0200
#define REGULAR_FONTTYPE                0x0400

#define OUT_DEFAULT_PRECIS              0
#define OUT_STRING_PRECIS               1
#define OUT_CHARACTER_PRECIS            2
#define OUT_STROKE_PRECIS               3

#define CLIP_DEFAULT_PRECIS             0
#define CLIP_CHARACTER_PRECIS           1
#define CLIP_STROKE_PRECIS              2

#define DEFAULT_QUALITY                 0
#define DRAFT_QUALITY                   1
#define PROOF_QUALITY                   2

#define DEFAULT_PITCH                   0
#define FIXED_PITCH                     1
#define VARIABLE_PITCH                  2

#define ANSI_CHARSET                    0
#define SYMBOL_CHARSET                  2
#define SHIFTJIS_CHARSET                128
#define OEM_CHARSET                     255

/* Font Families */
#define FF_DONTCARE                     0
#define FF_ROMAN                        16

/* Times Roman, Century Schoolbook, etc. */
#define FF_SWISS                        32

/* Helvetica, Swiss, etc. */
#define FF_MODERN                       48

/* Pica, Elite, Courier, etc. */
#define FF_SCRIPT                       64
#define FF_DECORATIVE                   80

/* Font Weights */
#define FW_DONTCARE                     0
#define FW_THIN                         100
#define FW_EXTRALIGHT                   200
#define FW_LIGHT                        300
#define FW_NORMAL                       400
#define FW_MEDIUM                       500
#define FW_SEMIBOLD                     600
#define FW_BOLD                         700
#define FW_EXTRABOLD                    800
#define FW_HEAVY                        900

#define FW_ULTRALIGHT                   FW_EXTRALIGHT
#define FW_REGULAR                      FW_NORMAL
#define FW_DEMIBOLD                     FW_SEMIBOLD
#define FW_ULTRABOLD                    FW_EXTRABOLD
#define FW_BLACK                        FW_HEAVY

/* Background Modes */
#define TRANSPARENT                     1
#define OPAQUE                          2

/* Mapping Modes */
#define MM_TEXT                         1
#define MM_LOMETRIC                     2
#define MM_HIMETRIC                     3
#define MM_LOENGLISH                    4
#define MM_HIENGLISH                    5
#define MM_TWIPS                        6
#define MM_ISOTROPIC                    7
#define MM_ANISOTROPIC                  8

/* Coordinate Modes */
#define ABSOLUTE                        1
#define RELATIVE                        2

/* Stock Logical Objects */
#define WHITE_BRUSH                     0
#define LTGRAY_BRUSH                    1
#define GRAY_BRUSH                      2
#define DKGRAY_BRUSH                    3
#define BLACK_BRUSH                     4
#define NULL_BRUSH                      5
#define HOLLOW_BRUSH                    NULL_BRUSH
#define WHITE_PEN                       6
#define BLACK_PEN                       7
#define NULL_PEN                        8
#define OEM_FIXED_FONT                  10
#define ANSI_FIXED_FONT                 11
#define ANSI_VAR_FONT                   12
#define SYSTEM_FONT                     13
#define DEVICE_DEFAULT_FONT             14
#define DEFAULT_PALETTE                 15
#define SYSTEM_FIXED_FONT               16

/* Brush Styles */
#define BS_SOLID                        0
#define BS_NULL                         1
#define BS_HOLLOW                       BS_NULL
#define BS_HATCHED                      2
#define BS_PATTERN                      3
#define BS_INDEXED                      4
#define BS_DIBPATTERN                   5

/* Hatch Styles */
#define HS_HORIZONTAL                   0
#define HS_VERTICAL                     1
#define HS_FDIAGONAL                    2
#define HS_BDIAGONAL                    3
#define HS_CROSS                        4
#define HS_DIAGCROSS                    5

/* Pen Styles */
#define PS_SOLID                        0
#define PS_DASH                         1
#define PS_DOT                          2
#define PS_DASHDOT                      3
#define PS_DASHDOTDOT                   4
#define PS_NULL                         5
#define PS_INSIDEFRAME                  6

/* Device Parameters for GetDeviceCaps() */
#define DRIVERVERSION                   0
#define TECHNOLOGY                      2
#define HORZSIZE                        4
#define VERTSIZE                        6
#define HORZRES                         8
#define VERTRES                         10
#define BITSPIXEL                       12
#define PLANES                          14
#define NUMBRUSHES                      16
#define NUMPENS                         18
#define NUMMARKERS                      20
#define NUMFONTS                        22
#define NUMCOLORS                       24
#define PDEVICESIZE                     26
#define CURVECAPS                       28
#define LINECAPS                        30
#define POLYGONALCAPS                   32
#define TEXTCAPS                        34
#define CLIPCAPS                        36
#define RASTERCAPS                      38
#define ASPECTX                         40
#define ASPECTY                         42
#define ASPECTXY                        44

#define LOGPIXELSX                      88
#define LOGPIXELSY                      90

#define SIZEPALETTE                     104
#define NUMRESERVED                     106
#define COLORRES                        108


/* Device Capability Masks: */

/* Device Technologies */
#define DT_PLOTTER                      0
#define DT_RASDISPLAY                   1
#define DT_RASPRINTER                   2
#define DT_RASCAMERA                    3
#define DT_CHARSTREAM                   4
#define DT_METAFILE                     5
#define DT_DISPFILE                     6

/* Curve Capabilities */
#define CC_NONE                         0
#define CC_CIRCLES                      1
#define CC_PIE                          2
#define CC_CHORD                        4
#define CC_ELLIPSES                     8
#define CC_WIDE                         16
#define CC_STYLED                       32
#define CC_WIDESTYLED                   64
#define CC_INTERIORS                    128

/* Line Capabilities */
#define LC_NONE                         0
#define LC_POLYLINE                     2
#define LC_MARKER                       4
#define LC_POLYMARKER                   8
#define LC_WIDE                         16
#define LC_STYLED                       32
#define LC_WIDESTYLED                   64
#define LC_INTERIORS                    128

/* Polygonal Capabilities */
#define PC_NONE                         0
#define PC_POLYGON                      1
#define PC_RECTANGLE                    2
#define PC_WINDPOLYGON                  4
#define PC_TRAPEZOID                    4
#define PC_SCANLINE                     8
#define PC_WIDE                         16
#define PC_STYLED                       32
#define PC_WIDESTYLED                   64
#define PC_INTERIORS                    128

/* Polygonal Capabilities */
#define CP_NONE                         0
#define CP_RECTANGLE                    1

/* Text Capabilities */
#define TC_OP_CHARACTER                 0x1
#define TC_OP_STROKE                    0x2
#define TC_CP_STROKE                    0x4
#define TC_CR_90                        0x8
#define TC_CR_ANY                       0x10
#define TC_SF_X_YINDEP                  0x20
#define TC_SA_DOUBLE                    0x40
#define TC_SA_WORD                      0x80
#define TC_SA_CONTIN                    0x100
#define TC_EA_DOUBLE                    0x200
#define TC_IA_ABLE                      0x400
#define TC_UA_ABLE                      0x800
#define TC_SO_ABLE                      0x1000
#define TC_RA_ABLE                      0x2000
#define TC_VA_ABLE                      0x4000
#define TC_RESERVED                     0x8000

/* Raster Capabilities */
#define RC_BITBLT                       1
#define RC_BANDING                      2
#define RC_SCALING                      4
#define RC_BITMAP64                     8
#define RC_GDI20_OUTPUT                 0x10
#define RC_DI_BITMAP                    0x80
#define RC_PALETTE                      0x100
#define RC_DIBTODEV                     0x200
#define RC_BIGFONT                      0x400
#define RC_STRETCHBLT                   0x800
#define RC_FLOODFILL                    0x1000
#define RC_STRETCHDIB                   0x2000

/* palette entry flags */
#define PC_RESERVED                     0x1
#define PC_EXPLICIT                     0x2
#define PC_NOCOLLAPSE                   0x4

/* DIB color table identifiers */
#define DIB_RGB_COLORS                  0
#define DIB_PAL_COLORS                  1

/* constants for Get/SetSystemPaletteUse() */
#define SYSPAL_STATIC                   1
#define SYSPAL_NOSTATIC                 2

/* constants for CreateDIBitmap */
#define CBM_INIT                        0x4

/* DrawText() Format Flags */
#define DT_TOP                          0x0
#define DT_LEFT                         0x0
#define DT_CENTER                       0x1
#define DT_RIGHT                        0x2
#define DT_VCENTER                      0x4
#define DT_BOTTOM                       0x8
#define DT_WORDBREAK                    0x10
#define DT_SINGLELINE                   0x20
#define DT_EXPANDTABS                   0x40
#define DT_TABSTOP                      0x80
#define DT_NOCLIP                       0x100
#define DT_EXTERNALLEADING              0x200
#define DT_CALCRECT                     0x400
#define DT_NOPREFIX                     0x800
#define DT_INTERNAL                     0x1000

/* ExtFloodFill style flags */
#define FLOODFILLBORDER                 0
#define FLOODFILLSURFACE                1

/* Scroll Bar Constants */
#define SB_HORZ                         0
#define SB_VERT                         1
#define SB_CTL                          2
#define SB_BOTH                         3

/* Scroll Bar Commands */
#define SB_LINEUP                       0
#define SB_LINEDOWN                     1
#define SB_PAGEUP                       2
#define SB_PAGEDOWN                     3
#define SB_THUMBPOSITION                4
#define SB_THUMBTRACK                   5
#define SB_TOP                          6
#define SB_BOTTOM                       7
#define SB_ENDSCROLL                    8

/* ShowWindow() Commands */
#define SW_HIDE                         0
#define SW_SHOWNORMAL                   1
#define SW_NORMAL                       1
#define SW_SHOWMINIMIZED                2
#define SW_SHOWMAXIMIZED                3
#define SW_MAXIMIZE                     3
#define SW_SHOWNOACTIVATE               4
#define SW_SHOW                         5
#define SW_MINIMIZE                     6
#define SW_SHOWMINNOACTIVE              7
#define SW_SHOWNA                       8
#define SW_RESTORE                      9

/* Old ShowWindow() Commands */
#define HIDE_WINDOW                     0
#define SHOW_OPENWINDOW                 1
#define SHOW_ICONWINDOW                 2
#define SHOW_FULLSCREEN                 3
#define SHOW_OPENNOACTIVATE             4

/* Identifiers for the WM_SHOWWINDOW message */
#define SW_PARENTCLOSING                1
#define SW_OTHERZOOM                    2
#define SW_PARENTOPENING                3
#define SW_OTHERUNZOOM                  4

/* Region Flags */
#define ERRORAPI                        0
#define NULLREGION                      1
#define SIMPLEREGION                    2
#define COMPLEXREGION                   3

/* CombineRgn() Styles */
#define RGN_AND                         1
#define RGN_OR                          2
#define RGN_XOR                         3
#define RGN_DIFF                        4
#define RGN_COPY                        5

/* Virtual Keys, Standard Set */
#define VK_LBUTTON                      0x1
#define VK_RBUTTON                      0x2
#define VK_CANCEL                       0x3
#define VK_MBUTTON                      0x4
#define VK_BACK                         0x8
#define VK_TAB                          0x9
#define VK_CLEAR                        0xC
#define VK_RETURN                       0xD
#define VK_SHIFT                        0x10
#define VK_CONTROL                      0x11
#define VK_MENU                         0x12
#define VK_PAUSE                        0x13
#define VK_CAPITAL                      0x14
#define VK_ESCAPE                       0x1B
#define VK_SPACE                        0x20
#define VK_PRIOR                        0x21
#define VK_NEXT                         0x22
#define VK_END                          0x23
#define VK_HOME                         0x24
#define VK_LEFT                         0x25
#define VK_UP                           0x26
#define VK_RIGHT                        0x27
#define VK_DOWN                         0x28
#define VK_SELECT                       0x29
#define VK_PRINT                        0x2A
#define VK_EXECUTE                      0x2B
#define VK_SNAPSHOT                     0x2C
#define VK_INSERT                       0x2D
#define VK_DELETE                       0x2E
#define VK_HELP                         0x2F

#define VK_PGUP                         0x21
#define VK_PGDN                         0x22

#define VK_NUMPAD0                      0x60
#define VK_NUMPAD1                      0x61
#define VK_NUMPAD2                      0x62
#define VK_NUMPAD3                      0x63
#define VK_NUMPAD4                      0x64
#define VK_NUMPAD5                      0x65
#define VK_NUMPAD6                      0x66
#define VK_NUMPAD7                      0x67
#define VK_NUMPAD8                      0x68
#define VK_NUMPAD9                      0x69
#define VK_MULTIPLY                     0x6A
#define VK_ADD                          0x6B
#define VK_SEPARATOR                    0x6C
#define VK_SUBTRACT                     0x6D
#define VK_DECIMAL                      0x6E
#define VK_DIVIDE                       0x6F
#define VK_F1                           0x70
#define VK_F2                           0x71
#define VK_F3                           0x72
#define VK_F4                           0x73
#define VK_F5                           0x74
#define VK_F6                           0x75
#define VK_F7                           0x76
#define VK_F8                           0x77
#define VK_F9                           0x78
#define VK_F10                          0x79
#define VK_F11                          0x7A
#define VK_F12                          0x7B
#define VK_F13                          0x7C
#define VK_F14                          0x7D
#define VK_F15                          0x7E
#define VK_F16                          0x7F

#define VK_NUMLOCK                      0x90

/* SetWindowsHook() codes */
#define WH_MSGFILTER                    -1
#define WH_JOURNALRECORD                0
#define WH_JOURNALPLAYBACK              1
#define WH_KEYBOARD                     2
#define WH_GETMESSAGE                   3
#define WH_CALLWNDPROC                  4
#define WH_CBT                          5
#define WH_SYSMSGFILTER                 6
#define WH_WINDOWMGR                    7

/* Hook Codes */
#define HC_LPLPFNNEXT                   -2
#define HC_LPFNNEXT                     -1
#define HC_ACTION                       0
#define HC_GETNEXT                      1
#define HC_SKIP                         2
#define HC_NOREM                        3
#define HC_NOREMOVE                     3
#define HC_SYSMODALON                   4
#define HC_SYSMODALOFF                  5

/* CBT Hook Codes */
#define HCBT_MOVESIZE                   0
#define HCBT_MINMAX                     1
#define HCBT_QS                         2

/* WH_MSGFILTER Filter Proc Codes */
#define MSGF_DIALOGBOX                  0
#define MSGF_MESSAGEBOX                 1
#define MSGF_MENU                       2
#define MSGF_MOVE                       3
#define MSGF_SIZE                       4
#define MSGF_SCROLLBAR                  5
#define MSGF_NEXTWINDOW                 6

/* Window Manager Hook Codes */
#define WC_INIT                         1
#define WC_SWP                          2
#define WC_DEFWINDOWPROC                3
#define WC_MINMAX                       4
#define WC_MOVE                         5
#define WC_SIZE                         6
#define WC_DRAWCAPTION                  7

/* Window field offsets for GetWindowLong() and GetWindowWord() */
#define GWL_WNDPROC                     -4
#define GWW_HINSTANCE                   -6
#define GWW_HWNDPARENT                  -8
#define GWW_ID                          -12
#define GWL_STYLE                       -16
#define GWL_EXSTYLE                     -20

/* Class field offsets for GetClassLong() and GetClassWord() */
#define GCL_MENUNAME                    -8
#define GCW_HBRBACKGROUND               -10
#define GCW_HCURSOR                     -12
#define GCW_HICON                       -14
#define GCW_HMODULE                     -16
#define GCW_CBWNDEXTRA                  -18
#define GCW_CBCLSEXTRA                  -20
#define GCL_WNDPROC                     -24
#define GCW_STYLE                       -26

/* Window Messages */
#define WM_ACTIVATE                     0x0006
#define WM_ACTIVATEAPP                  0x001C
#define WM_ASKCBFORMATNAME              0x030C
#define WM_CANCELMODE                   0x001F
#define WM_CHANGECBCHAIN                0x030D
#define WM_CHAR                         0x0102
#define WM_CHARTOITEM                   0x002F
#define WM_CHILDACTIVATE                0x0022
#define WM_CLEAR                        0x0303
#define WM_CLOSE                        0x0010
#define WM_COMMAND                      0x0111
#define WM_COMPACTING                   0x0041
#define WM_COMPAREITEM                  0x0039
#define WM_COPY                         0x0301
#define WM_CREATE                       0x0001
#define WM_CTLCOLOR                     0x0019
#define WM_CUT                          0x0300
#define WM_DEADCHAR                     0x0103
#define WM_DELETEITEM                   0x002D
#define WM_DESTROY                      0x0002
#define WM_DESTROYCLIPBOARD             0x0307
#define WM_DEVMODECHANGE                0x001B
#define WM_DRAWCLIPBOARD                0x0308
#define WM_DRAWITEM                     0x002B
#define WM_ENABLE                       0x000A
#define WM_ENDSESSION                   0x0016
#define WM_ENTERIDLE                    0x0121
#define WM_ERASEBKGND                   0x0014
#define WM_FONTCHANGE                   0x001D
#define WM_GETDLGCODE                   0x0087
#define WM_GETFONT                      0x0031
#define WM_GETMINMAXINFO                0x0024
#define WM_GETTEXT                      0x000D
#define WM_GETTEXTLENGTH                0x000E
#define WM_HSCROLL                      0x0114
#define WM_HSCROLLCLIPBOARD             0x030E
#define WM_ICONERASEBKGND               0x0027
#define WM_INITDIALOG                   0x0110
#define WM_INITMENU                     0x0116
#define WM_INITMENUPOPUP                0x0117
#define WM_KEYDOWN                      0x0100
#define WM_KEYFIRST                     0x0100
#define WM_KEYLAST                      0x0108
#define WM_KEYUP                        0x0101
#define WM_KILLFOCUS                    0x0008
#define WM_LBUTTONDBLCLK                0x0203
#define WM_LBUTTONDOWN                  0x0201
#define WM_LBUTTONUP                    0x0202
#define WM_MBUTTONDBLCLK                0x0209
#define WM_MBUTTONDOWN                  0x0207
#define WM_MBUTTONUP                    0x0208
#define WM_MDIACTIVATE                  0x0222
#define WM_MDICASCADE                   0x0227
#define WM_MDICREATE                    0x0220
#define WM_MDIDESTROY                   0x0221
#define WM_MDIGETACTIVE                 0x0229
#define WM_MDIICONARRANGE               0x0228
#define WM_MDIMAXIMIZE                  0x0225
#define WM_MDINEXT                      0x0224
#define WM_MDIRESTORE                   0x0223
#define WM_MDISETMENU                   0x0230
#define WM_MDITILE                      0x0226
#define WM_MEASUREITEM                  0x002C
#define WM_MENUCHAR                     0x0120
#define WM_MENUSELECT                   0x011F
#define WM_MOUSEACTIVATE                0x0021
#define WM_MOUSEFIRST                   0x0200
#define WM_MOUSELAST                    0x0209
#define WM_MOUSEMOVE                    0x0200
#define WM_MOVE                         0x0003
#define WM_NCACTIVATE                   0x0086
#define WM_NCCALCSIZE                   0x0083
#define WM_NCCREATE                     0x0081
#define WM_NCDESTROY                    0x0082
#define WM_NCHITTEST                    0x0084
#define WM_NCLBUTTONDBLCLK              0x00A3
#define WM_NCLBUTTONDOWN                0x00A1
#define WM_NCLBUTTONUP                  0x00A2
#define WM_NCMBUTTONDBLCLK              0x00A9
#define WM_NCMBUTTONDOWN                0x00A7
#define WM_NCMBUTTONUP                  0x00A8
#define WM_NCMOUSEMOVE                  0x00A0
#define WM_NCPAINT                      0x0085
#define WM_NCRBUTTONDBLCLK              0x00A6
#define WM_NCRBUTTONDOWN                0x00A4
#define WM_NCRBUTTONUP                  0x00A5
#define WM_NEXTDLGCTL                   0x0028
#define WM_NULL                         0x0000
#define WM_PAINT                        0x000F
#define WM_PAINTCLIPBOARD               0x0309
#define WM_PAINTICON                    0x0026
#define WM_PALETTECHANGED               0x0311
#define WM_PALETTEISCHANGING            0x0310
#define WM_PARENTNOTIFY                 0x0210
#define WM_PASTE                        0x0302
#define WM_QUERYDRAGICON                0x0037
#define WM_QUERYENDSESSION              0x0011
#define WM_QUERYNEWPALETTE              0x030F
#define WM_QUERYOPEN                    0x0013
#define WM_QUEUESYNC                    0x0023
#define WM_QUIT                         0x0012
#define WM_RBUTTONDBLCLK                0x0206
#define WM_RBUTTONDOWN                  0x0204
#define WM_RBUTTONUP                    0x0205
#define WM_RENDERALLFORMATS             0x0306
#define WM_RENDERFORMAT                 0x0305
#define WM_SETCURSOR                    0x0020
#define WM_SETFOCUS                     0x0007
#define WM_SETFONT                      0x0030
#define WM_SETREDRAW                    0x000B
#define WM_SETTEXT                      0x000C
#define WM_SHOWWINDOW                   0x0018
#define WM_SIZE                         0x0005
#define WM_SIZECLIPBOARD                0x030B
#define WM_SPOOLERSTATUS                0x002A
#define WM_SYSCHAR                      0x0106
#define WM_SYSCOLORCHANGE               0x0015
#define WM_SYSCOMMAND                   0x0112
#define WM_SYSDEADCHAR                  0x0107
#define WM_SYSKEYDOWN                   0x0104
#define WM_SYSKEYUP                     0x0105
#define WM_TIMECHANGE                   0x001E
#define WM_TIMER                        0x0113
#define WM_UNDO                         0x0304
#define WM_VKEYTOITEM                   0x002E
#define WM_VSCROLL                      0x0115
#define WM_VSCROLLCLIPBOARD             0x030A
#define WM_WININICHANGE                 0x001A

/* NOTE: All Message Numbers below 0x0400 are Reserved. */

/* Private Window Messages Start Here: */
#define WM_USER                         0x400

/* WM_SYNCTASK Commands */
#define ST_BEGINSWP                     0
#define ST_ENDSWP                       1

/* WinWhere() Area Codes */
#define HTERROR                         -2
#define HTTRANSPARENT                   -1
#define HTNOWHERE                       0
#define HTCLIENT                        1
#define HTCAPTION                       2
#define HTSYSMENU                       3
#define HTGROWBOX                       4
#define HTSIZE                          HTGROWBOX
#define HTMENU                          5
#define HTHSCROLL                       6
#define HTVSCROLL                       7
#define HTREDUCE                        8
#define HTZOOM                          9
#define HTLEFT                          10
#define HTRIGHT                         11
#define HTTOP                           12
#define HTTOPLEFT                       13
#define HTTOPRIGHT                      14
#define HTBOTTOM                        15
#define HTBOTTOMLEFT                    16
#define HTBOTTOMRIGHT                   17
#define HTSIZEFIRST                     HTLEFT
#define HTSIZELAST                      HTBOTTOMRIGHT

/* WM_MOUSEACTIVATE Return Codes */
#define MA_ACTIVATE                     1
#define MA_ACTIVATEANDEAT               2
#define MA_NOACTIVATE                   3

/* Size Message Commands */
#define SIZENORMAL                      0
#define SIZEICONIC                      1
#define SIZEFULLSCREEN                  2
#define SIZEZOOMSHOW                    3
#define SIZEZOOMHIDE                    4

/* Key State Masks for Mouse Messages */
#define MK_LBUTTON                      0x1
#define MK_RBUTTON                      0x2
#define MK_SHIFT                        0x4
#define MK_CONTROL                      0x8
#define MK_MBUTTON                      0x10

/*** Basic window types ***/
#define WS_OVERLAPPED                   0x00000000
#define WS_POPUP                        0x80000000
#define WS_CHILD                        0x40000000

/*** Clipping styles ***/
#define WS_CLIPSIBLINGS                 0x04000000
#define WS_CLIPCHILDREN                 0x02000000

/*** Generic window states ***/
#define WS_VISIBLE                      0x10000000
#define WS_DISABLED                     0x08000000

/*** Main window states ***/
#define WS_MINIMIZE                     0x20000000
#define WS_MAXIMIZE                     0x01000000

/*** Main window styles ***/
#define WS_BORDER                       0x00800000
#define WS_DLGFRAME                     0x00400000
#define WS_CAPTION                      0x00C00000
#define WS_VSCROLL                      0x00200000
#define WS_HSCROLL                      0x00100000
#define WS_SYSMENU                      0x00080000
#define WS_THICKFRAME                   0x00040000
#define WS_MINIMIZEBOX                  0x00020000
#define WS_MAXIMIZEBOX                  0x00010000

/*** Control window styles ***/
#define WS_GROUP                        0x00020000
#define WS_TABSTOP                      0x00010000

/*** Common Window Styles ***/
#define WS_OVERLAPPEDWINDOW             WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_THICKFRAME | WS_MINIMIZEBOX | WS_MAXIMIZEBOX
#define WS_CHILDWINDOW                  WS_CHILD
#define WS_TILEDWINDOW                  WS_OVERLAPPEDWINDOW

/* Extended Window Styles */
#define WS_EX_DLGMODALFRAME             0x00001
#define WS_EX_NOPARENTNOTIFY            0x00004
#define WS_EX_TOPMOST                   0x00000008
#define WS_EX_ACCEPTFILES               0x00000010
#define WS_EX_TRANSPARENT               0x00000020
#define WS_EX_MDICHILD                  0x00000040
#define WS_EX_TOOLWINDOW                0x00000080
#define WS_EX_WINDOWEDGE                0x00000100
#define WS_EX_CLIENTEDGE                0x00000200
#define WS_EX_CONTEXTHELP               0x00000400
#define WS_EX_RIGHT                     0x00001000
#define WS_EX_LEFT                      0x00000000
#define WS_EX_RTLREADING                0x00002000
#define WS_EX_LTRREADING                0x00000000
#define WS_EX_LEFTSCROLLBAR             0x00004000
#define WS_EX_RIGHTSCROLLBAR            0x00000000
#define WS_EX_CONTROLPARENT             0x00010000
#define WS_EX_STATICEDGE                0x00020000
#define WS_EX_APPWINDOW                 0x00040000
#define WS_EX_OVERLAPPEDWINDOW          WS_EX_WINDOWEDGE | WS_EX_CLIENTEDGE
#define WS_EX_PALETTEWINDOW             WS_EX_WINDOWEDGE | WS_EX_TOOLWINDOW | WS_EX_TOPMOST


/* Class styles */
#define CS_VREDRAW                      0x1
#define CS_HREDRAW                      0x2
#define CS_KEYCVTWINDOW                 0x4
#define CS_DBLCLKS                      0x8
#define CS_OWNDC                        0x20
#define CS_CLASSDC                      0x40
#define CS_PARENTDC                     0x80
#define CS_NOKEYCVT                     0x100
#define CS_NOCLOSE                      0x200
#define CS_SAVEBITS                     0x800
#define CS_BYTEALIGNCLIENT              0x1000
#define CS_BYTEALIGNWINDOW              0x2000
#define CS_GLOBALCLASS                  0x4000

/* Clipboard Formats */
#define CF_TEXT                         1
#define CF_BITMAP                       2
#define CF_METAFILEPICT                 3
#define CF_SYLK                         4
#define CF_DIF                          5
#define CF_TIFF                         6
#define CF_OEMTEXT                      7
#define CF_DIB                          8
#define CF_PALETTE                      9

#define CF_OWNERDISPLAY                 0x80
#define CF_DSPTEXT                      0x81
#define CF_DSPBITMAP                    0x82
#define CF_DSPMETAFILEPICT              0x83

#define CF_PRIVATEFIRST                 0x200
#define CF_PRIVATELAST                  0x2FF

/* "GDIOBJ" formats do get DeleteObject() */
#define CF_GDIOBJFIRST                  0x300
#define CF_GDIOBJLAST                   0x3FF

/* Owner draw control types */
#define ODT_MENU                        1
#define ODT_LISTBOX                     2
#define ODT_COMBOBOX                    3
#define ODT_BUTTON                      4

/* Owner draw actions */
#define ODA_DRAWENTIRE                  0x1
#define ODA_SELECT                      0x2
#define ODA_FOCUS                       0x4

/* Owner draw state */
#define ODS_SELECTED                    0x1
#define ODS_GRAYED                      0x2
#define ODS_DISABLED                    0x4
#define ODS_CHECKED                     0x8
#define ODS_FOCUS                       0x10

/* PeekMessage() Options */
#define PM_NOREMOVE                     0x0
#define PM_REMOVE                       0x1
#define PM_NOYIELD                      0x2

/* Flags for _lopen */
#define READAPI                         0
#define WRITEAPI                        1
#define READ_WRITE                      2

#define EW_RESTARTWINDOWS               0x42

/* Special HWND value for use with PostMessage and SendMessage */
#define HWND_BROADCAST                  0xFFFF

#define CW_USEDEFAULT                   0x8000
#define HWND_DESKTOP                    0

/* SetWindowPos Flags */
#define SWP_NOSIZE                      0x1
#define SWP_NOMOVE                      0x2
#define SWP_NOZORDER                    0x4
#define SWP_NOREDRAW                    0x8
#define SWP_NOACTIVATE                  0x10
#define SWP_DRAWFRAME                   0x20
#define SWP_SHOWWINDOW                  0x40
#define SWP_HIDEWINDOW                  0x80
#define SWP_NOCOPYBITS                  0x100
#define SWP_NOREPOSITION                0x200

/* SetWindowPos() hWndInsertAfter values */
#define HWND_TOP                         0
#define HWND_BOTTOM                      1
#define HWND_TOPMOST                    -1
#define HWND_NOTOPMOST                  -2

#define DLGWINDOWEXTRA                  30

/* GetSystemMetrics() codes */
#define SM_CXSCREEN                      0
#define SM_CYSCREEN                      1
#define SM_CXVSCROLL                     2
#define SM_CYHSCROLL                     3
#define SM_CYCAPTION                     4
#define SM_CXBORDER                      5
#define SM_CYBORDER                      6
#define SM_CXDLGFRAME                    7
#define SM_CYDLGFRAME                    8
#define SM_CYVTHUMB                      9
#define SM_CXHTHUMB                     10
#define SM_CXICON                       11
#define SM_CYICON                       12
#define SM_CXCURSOR                     13
#define SM_CYCURSOR                     14
#define SM_CYMENU                       15
#define SM_CXFULLSCREEN                 16
#define SM_CYFULLSCREEN                 17
#define SM_CYKANJIWINDOW                18
#define SM_MOUSEPRESENT                 19
#define SM_CYVSCROLL                    20
#define SM_CXHSCROLL                    21
#define SM_DEBUG                        22
#define SM_SWAPBUTTON                   23
#define SM_RESERVED1                    24
#define SM_RESERVED2                    25
#define SM_RESERVED3                    26
#define SM_RESERVED4                    27
#define SM_CXMIN                        28
#define SM_CYMIN                        29
#define SM_CXSIZE                       30
#define SM_CYSIZE                       31
#define SM_CXFRAME                      32
#define SM_CYFRAME                      33
#define SM_CXMINTRACK                   34
#define SM_CYMINTRACK                   35
#define SM_CMETRICS                     36

/* MessageBox() Flags */
#define MB_OK                           0x0
#define MB_OKCANCEL                     0x1
#define MB_ABORTRETRYIGNORE             0x2
#define MB_YESNOCANCEL                  0x3
#define MB_YESNO                        0x4
#define MB_RETRYCANCEL                  0x5

#define MB_ICONHAND                     0x10
#define MB_ICONQUESTION                 0x20
#define MB_ICONEXCLAMATION              0x30
#define MB_ICONASTERISK                 0x40

#define MB_ICONINFORMATION              MB_ICONASTERISK
#define MB_ICONSTOP                     MB_ICONHAND

#define MB_DEFBUTTON1                   0x0
#define MB_DEFBUTTON2                   0x100
#define MB_DEFBUTTON3                   0x200

#define MB_APPLMODAL                    0x0
#define MB_SYSTEMMODAL                  0x1000
#define MB_TASKMODAL                    0x2000

#define MB_NOFOCUS                      0x8000

#define MB_TYPEMASK                     0xF
#define MB_ICONMASK                     0xF0
#define MB_DEFMASK                      0xF00
#define MB_MODEMASK                     0x3000
#define MB_MISCMASK                     0xC000

/* Color TYPEs */
#define CTLCOLOR_MSGBOX                  0
#define CTLCOLOR_EDIT                    1
#define CTLCOLOR_LISTBOX                 2
#define CTLCOLOR_BTN                     3
#define CTLCOLOR_DLG                     4
#define CTLCOLOR_SCROLLBAR               5
#define CTLCOLOR_STATIC                  6
#define CTLCOLOR_MAX                     8

#define COLOR_SCROLLBAR                  0
#define COLOR_BACKGROUND                 1
#define COLOR_ACTIVECAPTION              2
#define COLOR_INACTIVECAPTION            3
#define COLOR_MENU                       4
#define COLOR_WINDOW                     5
#define COLOR_WINDOWFRAME                6
#define COLOR_MENUTEXT                   7
#define COLOR_WINDOWTEXT                 8
#define COLOR_CAPTIONTEXT                9
#define COLOR_ACTIVEBORDER              10
#define COLOR_INACTIVEBORDER            11
#define COLOR_APPWORKSPACE              12
#define COLOR_HIGHLIGHT                 13
#define COLOR_HIGHLIGHTTEXT             14
#define COLOR_BTNFACE                   15
#define COLOR_BTNSHADOW                 16
#define COLOR_GRAYTEXT                  17
#define COLOR_BTNTEXT                   18
#define COLOR_ENDCOLORS                 COLOR_BTNTEXT

/* GetWindow() Constants */
#define GW_HWNDFIRST                    0
#define GW_HWNDLAST                     1
#define GW_HWNDNEXT                     2
#define GW_HWNDPREV                     3
#define GW_OWNER                        4
#define GW_CHILD                        5

/* Menu flags for Add/Check/EnableMenuItem() */
#define MF_INSERT                       0x0
#define MF_CHANGE                       0x80
#define MF_APPEND                       0x100
#define MF_DELETE                       0x200
#define MF_REMOVE                       0x1000

#define MF_BYCOMMAND                    0x0
#define MF_BYPOSITION                   0x400

#define MF_SEPARATOR                    0x800

#define MF_ENABLED                      0x0
#define MF_GRAYED                       0x1
#define MF_DISABLED                     0x2

#define MF_UNCHECKED                    0x0
#define MF_CHECKED                      0x8
#define MF_USECHECKBITMAPS              0x200

#define MF_STRING                       0x0
#define MF_BITMAP                       0x4
#define MF_OWNERDRAW                    0x100

#define MF_POPUP                        0x10
#define MF_MENUBARBREAK                 0x20
#define MF_MENUBREAK                    0x40

#define MF_UNHILITE                     0x0
#define MF_HILITE                       0x80

#define MF_SYSMENU                      0x2000
#define MF_HELP                         0x4000
#define MF_MOUSESELECT                  0x8000

#define MF_END0x80

/* System Menu Command Values */
#define SC_SEPERATOR                    0x0000
#define SC_SIZE                         0xF000
#define SC_MOVE                         0xF010
#define SC_MINIMIZE                     0xF020
#define SC_MAXIMIZE                     0xF030
#define SC_NEXTWINDOW                   0xF040
#define SC_PREVWINDOW                   0xF050
#define SC_CLOSE                        0xF060
#define SC_VSCROLL                      0xF070
#define SC_HSCROLL                      0xF080
#define SC_MOUSEMENU                    0xF090
#define SC_KEYMENU                      0xF100
#define SC_ARRANGE                      0xF110
#define SC_RESTORE                      0xF120
#define SC_TASKLIST                     0xF130

#define SC_ICON                         SC_MINIMIZE
#define SC_ZOOM                         SC_MAXIMIZE

/* Standard Cursor IDs */
#define IDC_ARROW                       32512
#define IDC_IBEAM                       32513
#define IDC_WAIT                        32514
#define IDC_CROSS                       32515
#define IDC_UPARROW                     32516
#define IDC_SIZE                        32640
#define IDC_ICON                        32641
#define IDC_SIZENWSE                    32642
#define IDC_SIZENESW                    32643
#define IDC_SIZEWE                      32644
#define IDC_SIZENS                      32645

#define ORD_LANGDRIVER                  1

/* Standard Icon IDs */
#define IDI_APPLICATION                 32512
#define IDI_HAND                        32513
#define IDI_QUESTION                    32514
#define IDI_EXCLAMATION                 32515
#define IDI_ASTERISK                    32516

/* Dialog Box Command IDs */
#define IDOK                            1
#define IDCANCEL                        2
#define IDABORT                         3
#define IDRETRY                         4
#define IDIGNORE                        5
#define IDYES                           6
#define IDNO                            7

/* Edit Control Styles */
#define ES_LEFT                         0x0
#define ES_CENTER                       0x1
#define ES_RIGHT                        0x2
#define ES_MULTILINE                    0x4
#define ES_UPPERCASE                    0x8
#define ES_LOWERCASE                    0x10
#define ES_PASSWORD                     0x20
#define ES_AUTOVSCROLL                  0x40
#define ES_AUTOHSCROLL                  0x80
#define ES_NOHIDESEL                    0x100
#define ES_OEMCONVERT                   0x400

/* Edit Control Notification Codes */
#define EN_SETFOCUS                     0x100
#define EN_KILLFOCUS                    0x200
#define EN_CHANGE                       0x300
#define EN_UPDATE                       0x400
#define EN_ERRSPACE                     0x500
#define EN_MAXTEXT                      0x501
#define EN_HSCROLL                      0x601
#define EN_VSCROLL                      0x602

/* Edit Control Messages */
#define EM_GETSEL                      WM_USER +  0
#define EM_SETSEL                      WM_USER +  1
#define EM_GETRECT                     WM_USER +  2
#define EM_SETRECT                     WM_USER +  3
#define EM_SETRECTNP                   WM_USER +  4
#define EM_SCROLL                      WM_USER +  5
#define EM_LINESCROLL                  WM_USER +  6
#define EM_GETMODIFY                   WM_USER +  8
#define EM_SETMODIFY                   WM_USER +  9
#define EM_GETLINECOUNT                WM_USER + 10
#define EM_LINEINDEX                   WM_USER + 11
#define EM_SETHANDLE                   WM_USER + 12
#define EM_GETHANDLE                   WM_USER + 13
#define EM_GETTHUMB                    WM_USER + 14
#define EM_LINELENGTH                  WM_USER + 17
#define EM_REPLACESEL                  WM_USER + 18
#define EM_SETFONT                     WM_USER + 19
#define EM_GETLINE                     WM_USER + 20
#define EM_LIMITTEXT                   WM_USER + 21
#define EM_CANUNDO                     WM_USER + 22
#define EM_UNDO                        WM_USER + 23
#define EM_FMTLINES                    WM_USER + 24
#define EM_LINEFROMCHAR                WM_USER + 25
#define EM_SETWORDBREAK                WM_USER + 26
#define EM_SETTABSTOPS                 WM_USER + 27
#define EM_SETPASSWORDCHAR             WM_USER + 28
#define EM_EMPTYUNDOBUFFER             WM_USER + 29
#define EM_MSGMAX                      WM_USER + 30

/* Button Control Styles */
#define BS_PUSHBUTTON                   0x0
#define BS_DEFPUSHBUTTON                0x1
#define BS_CHECKBOX                     0x2
#define BS_AUTOCHECKBOX                 0x3
#define BS_RADIOBUTTON                  0x4
#define BS_3STATE                       0x5
#define BS_AUTO3STATE                   0x6
#define BS_GROUPBOX                     0x7
#define BS_USERBUTTON                   0x8
#define BS_AUTORADIOBUTTON              0x9
#define BS_PUSHBOX                      0xA
#define BS_OWNERDRAW                    0xB
#define BS_LEFTTEXT                     0x20

/* User Button Notification Codes */
#define BN_CLICKED                      0
#define BN_PAINT                        1
#define BN_HILITE                       2
#define BN_UNHILITE                     3
#define BN_DISABLE                      4
#define BN_DOUBLECLICKED                5

/* Button Control Messages */
#define BM_GETCHECK                     WM_USER + 0
#define BM_SETCHECK                     WM_USER + 1
#define BM_GETSTATE                     WM_USER + 2
#define BM_SETSTATE                     WM_USER + 3
#define BM_SETSTYLE                     WM_USER + 4

/* Static Control Constants */
#define SS_LEFT                         0x0
#define SS_CENTER                       0x1
#define SS_RIGHT                        0x2
#define SS_ICON                         0x3
#define SS_BLACKRECT                    0x4
#define SS_GRAYRECT                     0x5
#define SS_WHITERECT                    0x6
#define SS_BLACKFRAME                   0x7
#define SS_GRAYFRAME                    0x8
#define SS_WHITEFRAME                   0x9
#define SS_USERITEM                     0xA
#define SS_SIMPLE                       0xB
#define SS_LEFTNOWORDWRAP               0xC
#define SS_NOPREFIX                     0x80

/* Dialog Styles */
#define DS_ABSALIGN                     0x0001L
#define DS_SYSMODAL                     0x0002L
#define DS_3DLOOK                       0x0004L
#define DS_FIXEDSYS                     0x0008L
#define DS_NOFAILCREATE                 0x0010L
#define DS_LOCALEDIT                    0x0020L
#define DS_SETFONT                      0x0040L
#define DS_MODALFRAME                   0x0080L
#define DS_NOIDLEMSG                    0x0100L
#define DS_CONTROL                      0x0400L
#define DS_CENTER                       0x0800L
#define DS_CENTERMOUSE                  0x1000L
#define DS_CONTEXTHELP                  0x2000L


#define DM_GETDEFID                     WM_USER + 0
#define DM_SETDEFID                     WM_USER + 1
#define DC_HASDEFID                     0x534

/* Dialog Codes */
#define DLGC_WANTARROWS                 0x1
#define DLGC_WANTTAB                    0x2
#define DLGC_WANTALLKEYS                0x4
#define DLGC_WANTMESSAGE                0x4
#define DLGC_HASSETSEL                  0x8
#define DLGC_DEFPUSHBUTTON              0x10
#define DLGC_UNDEFPUSHBUTTON            0x20
#define DLGC_RADIOBUTTON                0x40
#define DLGC_WANTCHARS                  0x80
#define DLGC_STATIC                     0x100
#define DLGC_BUTTON                     0x2000

#define LB_CTLCODE                      0

/* Listbox Return Values */
#define LB_OKAY                          0
#define LB_ERR                          -1
#define LB_ERRSPACE                     -2

/*
   The idStaticPath parameter to DlgDirList can have the following values
   ORed if the list box should show other details of the files along with
   the name of the files;

   all other details also will be returned
*/

/* Listbox Notification Codes */
#define LBN_ERRSPACE                    -2
#define LBN_SELCHANGE                    1
#define LBN_DBLCLK                       2
#define LBN_SELCANCEL                    3
#define LBN_SETFOCUS                     4
#define LBN_KILLFOCUS                    5

/* Listbox messages */
#define LB_ADDSTRING                    WM_USER + 1
#define LB_INSERTSTRING                 WM_USER + 2
#define LB_DELETESTRING                 WM_USER + 3
#define LB_RESETCONTENT                 WM_USER + 5
#define LB_SETSEL                       WM_USER + 6
#define LB_SETCURSEL                    WM_USER + 7
#define LB_GETSEL                       WM_USER + 8
#define LB_GETCURSEL                    WM_USER + 9
#define LB_GETTEXT                      WM_USER + 10
#define LB_GETTEXTLEN                   WM_USER + 11
#define LB_GETCOUNT                     WM_USER + 12
#define LB_SELECTSTRING                 WM_USER + 13
#define LB_DIR                          WM_USER + 14
#define LB_GETTOPINDEX                  WM_USER + 15
#define LB_FINDSTRING                   WM_USER + 16
#define LB_GETSELCOUNT                  WM_USER + 17
#define LB_GETSELITEMS                  WM_USER + 18
#define LB_SETTABSTOPS                  WM_USER + 19
#define LB_GETHORIZONTALEXTENT          WM_USER + 20
#define LB_SETHORIZONTALEXTENT          WM_USER + 21
#define LB_SETCOLUMNWIDTH               WM_USER + 22
#define LB_SETTOPINDEX                  WM_USER + 24
#define LB_GETITEMRECT                  WM_USER + 25
#define LB_GETITEMDATA                  WM_USER + 26
#define LB_SETITEMDATA                  WM_USER + 27
#define LB_SELITEMRANGE                 WM_USER + 28
#define LB_MSGMAX                       WM_USER + 33

/* Listbox Styles */
#define LBS_NOTIFY                      0x1
#define LBS_SORT                        0x2
#define LBS_NOREDRAW                    0x4
#define LBS_MULTIPLESEL                 0x8
#define LBS_OWNERDRAWFIXED              0x10
#define LBS_OWNERDRAWVARIABLE           0x20
#define LBS_HASSTRINGS                  0x40
#define LBS_USETABSTOPS                 0x80
#define LBS_NOINTEGRALHEIGHT            0x100
#define LBS_MULTICOLUMN                 0x200
#define LBS_WANTKEYBOARDINPUT           0x400
#define LBS_EXTENDEDSEL                 0x800
#define LBS_STANDARD                    LBS_NOTIFY | LBS_SORT | WS_VSCROLL | WS_BORDER

/* Combo Box return Values */
#define CB_OKAY                          0
#define CB_ERR                          -1
#define CB_ERRSPACE                     -2

/* Combo Box Notification Codes */
#define CBN_ERRSPACE                    -1
#define CBN_SELCHANGE                    1
#define CBN_DBLCLK                       2
#define CBN_SETFOCUS                     3
#define CBN_KILLFOCUS                    4
#define CBN_EDITCHANGE                   5
#define CBN_EDITUPDATE                   6
#define CBN_DROPDOWN                     7

/* Combo Box styles */
#define CBS_SIMPLE                      0x1
#define CBS_DROPDOWN                    0x2
#define CBS_DROPDOWNLIST                0x3
#define CBS_OWNERDRAWFIXED              0x10
#define CBS_OWNERDRAWVARIABLE           0x20
#define CBS_AUTOHSCROLL                 0x40
#define CBS_OEMCONVERT                  0x80
#define CBS_SORT                        0x100
#define CBS_HASSTRINGS                  0x200
#define CBS_NOINTEGRALHEIGHT            0x400

/* Combo Box messages */
#define CB_GETEDITSEL                   WM_USER +  0
#define CB_LIMITTEXT                    WM_USER +  1
#define CB_SETEDITSEL                   WM_USER +  2
#define CB_ADDSTRING                    WM_USER +  3
#define CB_DELETESTRING                 WM_USER +  4
#define CB_DIR                          WM_USER +  5
#define CB_GETCOUNT                     WM_USER +  6
#define CB_GETCURSEL                    WM_USER +  7
#define CB_GETLBTEXT                    WM_USER +  8
#define CB_GETLBTEXTLEN                 WM_USER +  9
#define CB_INSERTSTRING                 WM_USER +  10
#define CB_RESETCONTENT                 WM_USER +  11
#define CB_FINDSTRING                   WM_USER +  12
#define CB_SELECTSTRING                 WM_USER +  13
#define CB_SETCURSEL                    WM_USER +  14
#define CB_SHOWDROPDOWN                 WM_USER +  15
#define CB_GETITEMDATA                  WM_USER +  16
#define CB_SETITEMDATA                  WM_USER +  17
#define CB_GETDROPPEDCONTROLRECT        WM_USER +  18
#define CB_MSGMAX                       WM_USER +  19

/* Scroll Bar Styles */
#define SBS_HORZ                        0
#define SBS_VERT                        1
#define SBS_TOPALIGN                    2
#define SBS_LEFTALIGN                   2
#define SBS_BOTTOMALIGN                 4
#define SBS_RIGHTALIGN                  4
#define SBS_SIZEBOXTOPLEFTALIGN         2
#define SBS_SIZEBOXBOTTOMRIGHTALIGN     4
#define SBS_SIZEBOX                     8

/* TAB control */
#define TCS_TABS                        0x0000
#define TCS_SINGLELINE                  0x0000
#define TCS_RIGHTJUSTIFY                0x0000
#define TCS_FORCEICONLEFT               0x0010
#define TCS_FORCELABELLEFT              0x0020
#define TCS_BUTTONS                     0x0100
#define TCS_MULTILINE                   0x0200
#define TCS_FIXEDWIDTH                  0x0400
#define TCS_RAGGEDRIGHT                 0x0800
#define TCS_FOCUSONBUTTONDOWN           0x1000
#define TCS_OWNERDRAWFIXED              0x2000
#define TCS_TOOLTIPS                    0x4000
#define TCS_FOCUSNEVER                  0x8000

/* COMM declarations */
#define NOPARITY                        0
#define ODDPARITY                       1
#define EVENPARITY                      2
#define MARKPARITY                      3
#define SPACEPARITY                     4

#define ONESTOPBIT                      0
#define ONE5STOPBITS                    1
#define TWOSTOPBITS                     2

#define IGNORE                          0
#define INFINITE                        0xFFFF

/* Error Flags
#define CE_RXOVER                       0x1
#define CE_OVERRUN                      0x2
#define CE_RXPARITY                     0x4
#define CE_FRAME                        0x8
#define CE_BREAK                        0x10
#define CE_CTSTO                        0x20
#define CE_DSRTO                        0x40
#define CE_RLSDTO                       0x80
#define CE_TXFULL                       0x100
#define CE_PTO                          0x200
#define CE_IOE                          0x400
#define CE_DNS                          0x800
#define CE_OOP                          0x1000
#define CE_MODE                         0x8000

#define IE_BADID                        -1
#define IE_OPEN                         -2
#define IE_NOPEN                        -3
#define IE_MEMORY                       -4
#define IE_DEFAULT                      -5
#define IE_HARDWARE                     -10
#define IE_BYTESIZE                     -11
#define IE_BAUDRATE                     -12

/* Events */
#define EV_RXCHAR                       0x1
#define EV_RXFLAG                       0x2
#define EV_TXEMPTY                      0x4
#define EV_CTS                          0x8
#define EV_DSR                          0x10
#define EV_RLSD                         0x20
#define EV_BREAK                        0x40
#define EV_ERR                          0x80
#define EV_RING                         0x100
#define EV_PERR                         0x200

/* Escape FUNCTIONs */
#define SETXOFF                         1
#define SETXON                          2
#define SETRTS                          3
#define CLRRTS                          4
#define SETDTR                          5
#define CLRDTR                          6
#define RESETDEV                        7

#define LPTx                            0x80

/* Commands to pass WinHelp() */
#define HELP_CONTEXT                    0x1
#define HELP_QUIT                       0x2
#define HELP_INDEX                      0x3
#define HELP_CONTENTS                   0x3
#define HELP_HELPONHELP                 0x4
#define HELP_SETINDEX                   0x5
#define HELP_SETCONTENTS                0x5
#define HELP_CONTEXTPOPUP               0x8
#define HELP_FORCEFILE                  0x9
#define HELP_KEY                        0x101
#define HELP_COMMAND                    0x102
#define HELP_PARTIALKEY                 0x105
#define HELP_MULTIKEY                   0x201
#define HELP_SETWINPOS                  0x203

#define GFSR_SYSTEMRESOURCES            0x0000
#define GFSR_GDIRESOURCES               0x0001
#define GFSR_USERRESOURCES              0x0002

/* ***** LogParamError/LogError values ***** */
/* Error modifier bits                       */
#define ERR_WARNING                     0x8000
#define ERR_PARAM                       0x4000

#define ERR_SIZE_MASK                   0x3000
#define ERR_BYTE                        0x1000
#define ERR_WORD                        0x2000
#define ERR_DWORD                       0x3000


/* ***** LogParamError() values ***** */
/* Generic parameter values */
#define ERR_BAD_VALUE                   0x6001
#define ERR_BAD_FLAGS                   0x6002
#define ERR_BAD_INDEX                   0x6003
#define ERR_BAD_DVALUE                  0x7004
#define ERR_BAD_DFLAGS                  0x7005
#define ERR_BAD_DINDEX                  0x7006
#define ERR_BAD_PTR                     0x7007
#define ERR_BAD_FUNC_PTR                0x7008
#define ERR_BAD_SELECTOR                0x6009
#define ERR_BAD_STRING_PTR              0x700A
#define ERR_BAD_HANDLE                  0x600B

/* KERNEL parameter errors */
#define ERR_BAD_HINSTANCE               0x6020
#define ERR_BAD_HMODULE                 0x6021
#define ERR_BAD_GLOBAL_HANDLE           0x6022
#define ERR_BAD_LOCAL_HANDLE            0x6023
#define ERR_BAD_ATOM                    0x6024
#define ERR_BAD_HFILE                   0x6025

/* USER parameter errors */
#define ERR_BAD_HWND                    0x6040
#define ERR_BAD_HMENU                   0x6041
#define ERR_BAD_HCURSOR                 0x6042
#define ERR_BAD_HICON                   0x6043
#define ERR_BAD_HDWP                    0x6044
#define ERR_BAD_CID                     0x6045
#define ERR_BAD_HDRVR                   0x6046

/* GDI parameter errors */
#define ERR_BAD_COORDS                  0x7060
#define ERR_BAD_GDI_OBJECT              0x6061
#define ERR_BAD_HDC                     0x6062
#define ERR_BAD_HPEN                    0x6063
#define ERR_BAD_HFONT                   0x6064
#define ERR_BAD_HBRUSH                  0x6065
#define ERR_BAD_HBITMAP                 0x6066
#define ERR_BAD_HRGN                    0x6067
#define ERR_BAD_HPALETTE                0x6068
#define ERR_BAD_HMETAFILE               0x6069

/* ***** LogError() values ***** */
/* KERNEL errors */
#define ERR_GALLOC                      0x0001
#define ERR_GREALLOC                    0x0002
#define ERR_GLOCK                       0x0003
#define ERR_LALLOC                      0x0004
#define ERR_LREALLOC                    0x0005
#define ERR_LLOCK                       0x0006
#define ERR_ALLOCRES                    0x0007
#define ERR_LOCKRES                     0x0008
#define ERR_LOADMODULE                  0x0009

/* USER errors */
#define ERR_CREATEDLG                   0x0040
#define ERR_CREATEDLG2                  0x0041
#define ERR_REGISTERCLASS               0x0042
#define ERR_DCBUSY                      0x0043
#define ERR_CREATEWND                   0x0044
#define ERR_STRUCEXTRA                  0x0045
#define ERR_LOADSTR                     0x0046
#define ERR_LOADMENU                    0x0047
#define ERR_NESTEDBEGINPAINT            0x0048
#define ERR_BADINDEX                    0x0049
#define ERR_CREATEMENU                  0x004A

/* GDI errors */
#define ERR_CREATEDC                    0x0080
#define ERR_CREATEMETA                  0x0081
#define ERR_DELOBJSELECTED              0x0082
#define ERR_SELBITMAP                   0x0083

/* WINDEBUGINFO flags values */
#define WDI_OPTIONS                     0x0001
#define WDI_FILTER                      0x0002
#define WDI_ALLOCBREAK                  0x0004

/* dwOptions values */
#define DBO_CHECKHEAP                   0x0001
#define DBO_BUFFERFILL                  0x0004
#define DBO_DISABLEGPTRAPPING           0x0010
#define DBO_CHECKFREE                   0x0020
#define DBO_SILENT                      0x8000
#define DBO_TRACEBREAK                  0x2000
#define DBO_WARNINGBREAK                0x1000
#define DBO_NOERRORBREAK                0x0800
#define DBO_NOFATALBREAK                0x0400
#define DBO_INT3BREAK                   0x0100

/* DebugOutput flags values */
#define DBF_TRACE                       0x0000
#define DBF_WARNING                     0x4000
#define DBF_ERROR                       0x8000
#define DBF_FATAL                       0xC000

/* dwFilter values */
#define DBF_KERNEL                      0x1000
#define DBF_KRN_MEMMAN                  0x0001
#define DBF_KRN_LOADMODULE              0x0002
#define DBF_KRN_SEGMENTLOAD             0x0004
#define DBF_USER                        0x0800
#define DBF_GDI                         0x0400
#define DBF_MMSYSTEM                    0x0040
#define DBF_PENWIN                      0x0020
#define DBF_APPLICATION                 0x0008
#define DBF_DRIVER                      0x0010

#define EW_REBOOTSYSTEM                 0x43

#define OBM_LFARROWI                    32734
#define OBM_RGARROWI                    32735
#define OBM_DNARROWI                    32736
#define OBM_UPARROWI                    32737

#define DCB_RESET                       0x0001
#define DCB_ACCUMULATE                  0x0002
#define DCB_DIRTY                       DCB_ACCUMULATE
#define DCB_SET                         DCB_RESET | DCB_ACCUMULATE
#define DCB_ENABLE                      0x0004
#define DCB_DISABLE                     0x0008

#define COLOR_INACTIVECAPTIONTEXT       19
#define COLOR_BTNHIGHLIGHT              20

#define OUT_TT_PRECIS                   4
#define OUT_DEVICE_PRECIS               5
#define OUT_RASTER_PRECIS               6
#define OUT_TT_ONLY_PRECIS              7

#define CLIP_LH_ANGLES                  0x10
#define CLIP_TT_ALWAYS                  0x20
#define CLIP_EMBEDDED                   0x80

#define TMPF_TRUETYPE                   0x04

/* ntmFlags field flags */
#define NTM_REGULAR                     0x00000040
#define NTM_BOLD                        0x00000020
#define NTM_ITALIC                      0x00000001

#define LF_FULLFACESIZE                 64

#define TRUETYPE_FONTTYPE               0x0004

/* GetGlyphOutline constants */
#define GGO_METRICS                     0
#define GGO_BITMAP                      1
#define GGO_NATIVE                      2

#define TT_POLYGON_TYPE                 24

#define TT_PRIM_LINE                     1
#define TT_PRIM_QSPLINE                  2

/* bits defined in wFlags of RASTERIZER_STATUS */
#define TT_AVAILABLE                    0x0001
#define TT_ENABLED                      0x0002

#define SM_CXDOUBLECLK                  36
#define SM_CYDOUBLECLK                  37
#define SM_CXICONSPACING                38
#define SM_CYICONSPACING                39
#define SM_MENUDROPALIGNMENT            40
#define SM_PENWINDOWS                   41
#define SM_DBCSENABLED                  42

#define SPI_GETBEEP                      1
#define SPI_SETBEEP                      2
#define SPI_GETMOUSE                     3
#define SPI_SETMOUSE                     4
#define SPI_GETBORDER                    5
#define SPI_SETBORDER                    6
#define SPI_GETKEYBOARDSPEED            10
#define SPI_SETKEYBOARDSPEED            11
#define SPI_LANGDRIVER                  12
#define SPI_ICONHORIZONTALSPACING       13
#define SPI_GETSCREENSAVETIMEOUT        14
#define SPI_SETSCREENSAVETIMEOUT        15
#define SPI_GETSCREENSAVEACTIVE         16
#define SPI_SETSCREENSAVEACTIVE         17
#define SPI_GETGRIDGRANULARITY          18
#define SPI_SETGRIDGRANULARITY          19
#define SPI_SETDESKWALLPAPER            20
#define SPI_SETDESKPATTERN              21
#define SPI_GETKEYBOARDDELAY            22
#define SPI_SETKEYBOARDDELAY            23
#define SPI_ICONVERTICALSPACING         24
#define SPI_GETICONTITLEWRAP            25
#define SPI_SETICONTITLEWRAP            26
#define SPI_GETMENUDROPALIGNMENT        27
#define SPI_SETMENUDROPALIGNMENT        28
#define SPI_SETDOUBLECLKWIDTH           29
#define SPI_SETDOUBLECLKHEIGHT          30
#define SPI_GETICONTITLELOGFONT         31
#define SPI_SETDOUBLECLICKTIME          32
#define SPI_SETMOUSEBUTTONSWAP          33
#define SPI_SETICONTITLELOGFONT         34
#define SPI_GETFASTTASKSWITCH           35
#define SPI_SETFASTTASKSWITCH           36

/* SystemParametersInfo flags */
#define SPIF_UPDATEINIFILE              0x0001
#define SPIF_SENDWININICHANGE           0x0002

/* GetQueueStatus flags */
#define QS_KEY                          0x0001
#define QS_MOUSEMOVE                    0x0002
#define QS_MOUSEBUTTON                  0x0004
#define QS_MOUSE                        QS_MOUSEMOVE | QS_MOUSEBUTTON
#define QS_POSTMESSAGE                  0x0008
#define QS_TIMER                        0x0010
#define QS_PAINT                        0x0020
#define QS_SENDMESSAGE                  0x0040

#define QS_ALLINPUT                     0x007f

/* ***** Power management ***** */

#define WM_POWER                        0x0048

/* wParam for WM_POWER window message and DRV_POWER driver notification */
#define PWR_OK                          1
#define PWR_FAIL                        -1
#define PWR_SUSPENDREQUEST              1
#define PWR_SUSPENDRESUME               2
#define PWR_CRITICALRESUME              3

#define GCW_ATOM                        -32

#define WPF_SETMINPOSITION              0x0001
#define WPF_RESTORETOMAXIMIZED          0x0002

#define WM_WINDOWPOSCHANGING            0x0046
#define WM_WINDOWPOSCHANGED             0x0047

#define DCX_WINDOW                      0x00000001
#define DCX_CACHE                       0x00000002
#define DCX_CLIPCHILDREN                0x00000008
#define DCX_CLIPSIBLINGS                0x00000010
#define DCX_PARENTCLIP                  0x00000020
#define DCX_EXCLUDERGN                  0x00000040
#define DCX_INTERSECTRGN                0x00000080
#define DCX_LOCKWINDOWUPDATE            0x00000400
#define DCX_USESTYLE                    0x00010000

#define RDW_INVALIDATE                  0x0001
#define RDW_INTERNALPAINT               0x0002
#define RDW_ERASE                       0x0004
#define RDW_VALIDATE                    0x0008
#define RDW_NOINTERNALPAINT             0x0010
#define RDW_NOERASE                     0x0020
#define RDW_NOCHILDREN                  0x0040
#define RDW_ALLCHILDREN                 0x0080
#define RDW_UPDATENOW                   0x0100
#define RDW_ERASENOW                    0x0200
#define RDW_FRAME                       0x0400
#define RDW_NOFRAME                     0x0800

#define SW_SCROLLCHILDREN               0x0001
#define SW_INVALIDATE                   0x0002
#define SW_ERASE                        0x0004

/* WM_NCCALCSIZE return flags */
#define WVR_ALIGNTOP                    0x0010
#define WVR_ALIGNLEFT                   0x0020
#define WVR_ALIGNBOTTOM                 0x0040
#define WVR_ALIGNRIGHT                  0x0080
#define WVR_HREDRAW                     0x0100
#define WVR_VREDRAW                     0x0200
#define WVR_REDRAW                      WVR_HREDRAW | WVR_VREDRAW
#define WVR_VALIDRECTS                  0x0400

#define MA_NOACTIVATEANDEAT              4

#define TPM_LEFTALIGN                   0x0000
#define TPM_RIGHTBUTTON                 0x0002
#define TPM_CENTERALIGN                 0x0004
#define TPM_RIGHTALIGN                  0x0008

#define MDIS_ALLCHILDSTYLES             0x0001

/* wParam values for WM_MDITILE and WM_MDICASCADE messages. */
#define MDITILE_VERTICAL                0x0000
#define MDITILE_HORIZONTAL              0x0001
#define MDITILE_SKIPDISABLED            0x0002

/* Static Control Mesages */
#define STM_SETICON                     WM_USER +  0
#define STM_GETICON                     WM_USER +  1

#define ES_READONLY                     0x00000800
#define ES_WANTRETURN                   0x00001000

#define EM_GETFIRSTVISIBLELINE          WM_USER +  30
#define EM_SETREADONLY                  WM_USER +  31
#define EM_SETWORDBREAKPROC             WM_USER +  32
#define EM_GETWORDBREAKPROC             WM_USER +  33
#define EM_GETPASSWORDCHAR              WM_USER +  34

/* EDITWORDBREAKPROC code values */
#define WB_LEFT                         0
#define WB_RIGHT                        1
#define WB_ISDELIMITER                  2

#define LBS_DISABLENOSCROLL             0x1000

#define LB_SETITEMHEIGHT                WM_USER + 33
#define LB_GETITEMHEIGHT                WM_USER + 34
#define LB_FINDSTRINGEXACT              WM_USER + 35

#define CBS_DISABLENOSCROLL             0x0800

#define CB_SETITEMHEIGHT                WM_USER +  19
#define CB_GETITEMHEIGHT                WM_USER +  20
#define CB_SETEXTENDEDUI                WM_USER +  21
#define CB_GETEXTENDEDUI                WM_USER +  22
#define CB_GETDROPPEDSTATE              WM_USER +  23
#define CB_FINDSTRINGEXACT              WM_USER +  24

#define CBN_CLOSEUP                     8
#define CBN_SELENDOK                    9
#define CBN_SELENDCANCEL                10

#define WH_DEBUG                        9
#define WH_HARDWARE                     8
#define WH_SHELL                        10

#define HSHELL_WINDOWCREATED            1
#define HSHELL_WINDOWDESTROYED          2
#define HSHELL_ACTIVATESHELLWINDOW      3

/* Flags returned by GetSystemDebugState. */
#define SDS_MENU                        0x0001
#define SDS_SYSMODAL                    0x0002
#define SDS_NOTASKQUEUE                 0x0004
#define SDS_DIALOG                      0x0008
#define SDS_TASKLOCKED                  0x0010

/* new escape functions */
#define GETMAXLPT                       8
#define GETMAXCOM                       9
#define GETBASEIRQ                      10

/* Comm Baud Rate indices */
#define CBR_110                         0xFF10
#define CBR_300                         0xFF11
#define CBR_600                         0xFF12
#define CBR_1200                        0xFF13
#define CBR_2400                        0xFF14
#define CBR_4800                        0xFF15
#define CBR_9600                        0xFF16
#define CBR_14400                       0xFF17
#define CBR_19200                       0xFF18
#define CBR_38400                       0xFF1B
#define CBR_56000                       0xFF1F
#define CBR_57600                       0xFF1F
#define CBR_128000                      0xFF23
#define CBR_256000                      0xFF27

#define WM_COMMNOTIFY                   0x0044

/* notifications passed in low word of lParam on WM_COMMNOTIFY messages */
#define CN_RECEIVE                      0x0001
#define CN_TRANSMIT                     0x0002
#define CN_EVENT                        0x0004

/* GetNextDriver flags */
#define GND_FIRSTINSTANCEONLY           0x00000001
#define GND_FORWARD                     0x00000000
#define GND_REVERSE                     0x00000002

/* Supported lParam1 of DRV_EXITAPPLICATION notification */
#define DRVEA_NORMALEXIT                0x0001
#define DRVEA_ABNORMALEXIT              0x0002

/* Supported return values for DRV_CONFIGURE message */
#define DRVCNF_CANCEL                   0x0000
#define DRVCNF_OK                       0x0001
#define DRVCNF_RESTART                  0x0002

/* Driver messages */
#define DRV_LOAD                        0x0001
#define DRV_ENABLE                      0x0002
#define DRV_OPEN                        0x0003
#define DRV_CLOSE                       0x0004
#define DRV_DISABLE                     0x0005
#define DRV_FREE                        0x0006
#define DRV_CONFIGURE                   0x0007
#define DRV_QUERYCONFIGURE              0x0008
#define DRV_INSTALL                     0x0009
#define DRV_REMOVE                      0x000A
#define DRV_EXITSESSION                 0x000B
#define DRV_EXITAPPLICATION             0x000C
#define DRV_POWER                       0x000F
#define DRV_RESERVED                    0x0800
#define DRV_USER                        0x4000

/* ** Return Codes ** */
#define WN_SUCCESS                      0x0000
#define WN_NOT_SUPPORTED                0x001
#define WN_NET_ERROR                    0x0002
#define WN_MORE_DATA                    0x0003
#define WN_BAD_POINTER                  0x0004
#define WN_BAD_VALUE                    0x0005
#define WN_BAD_PASSWORD                 0x0006
#define WN_ACCESS_DENIED                0x0007
#define WN_FUNCTION_BUSY                0x0008
#define WN_WINDOWS_ERROR                0x0009
#define WN_BAD_USER                     0x000A
#define WN_OUT_OF_MEMORY                0x000B
#define WN_CANCEL                       0x000C
#define WN_CONTINUE                     0x000D

#define WN_NOT_CONNECTED                0x0030
#define WN_OPEN_FILES                   0x0031
#define WN_BAD_NETNAME                  0x0032
#define WN_BAD_LOCALNAME                0x0033
#define WN_ALREADY_CONNECTED            0x0034
#define WN_DEVICE_ERROR                 0x0035
#define WN_CONNECTION_CLOSED            0x0036

/* ----- Version Symbols ----- */
#define VS_FILE_INFO                    16
#define VS_VERSION_INFO                 1
#define VS_USER_DEFINED                 100

/* ----- VS_VERSION.dwFileFlags ----- */
#define VS_FFI_SIGNATURE                0xFEEF04BDL
#define VS_FFI_STRUCVERSION             0x00010000L
#define VS_FFI_FILEFLAGSMASK            0x0000003FL

/* ----- VS_VERSION.dwFileFlags ----- */
#define VS_FF_DEBUG                     0x00000001L
#define VS_FF_PRERELEASE                0x00000002L
#define VS_FF_PATCHED                   0x00000004L
#define VS_FF_PRIVATEBUILD              0x00000008L
#define VS_FF_INFOINFERRED              0x00000010L
#define VS_FF_SPECIALBUILD              0x00000020L

/* ----- VS_VERSION.dwFileOS ----- */
#define VOS_UNKNOWN                     0x00000000L
#define VOS_DOS                         0x00010000L
#define VOS_OS216                       0x00020000L
#define VOS_OS232                       0x00030000L
#define VOS_NT                          0x00040000L

#define VOS_BASE                        0x00000000L
#define VOS_WINDOWS16                   0x00000001L
#define VOS_PM16                        0x00000002L
#define VOS_PM32                        0x00000003L
#define VOS_WINDOWS32                   0x00000004L

#define VOS_DOS_WINDOWS16               0x00010001L
#define VOS_DOS_WINDOWS32               0x00010004L
#define VOS_OS216_PM16                  0x00020002L
#define VOS_OS232_PM32                  0x00030003L
#define VOS_NT_WINDOWS32                0x00040004L

/* ----- VS_VERSION.dwFileType ----- */
#define VFT_UNKNOWN                     0x00000000L
#define VFT_APP                         0x00000001L
#define VFT_DLL                         0x00000002L
#define VFT_DRV                         0x00000003L
#define VFT_FONT                        0x00000004L
#define VFT_VXD                         0x00000005L
#define VFT_STATIC_LIB                  0x00000007L

/* ----- VS_VERSION.dwFileSubtype for VFT_WINDOWS_DRV ----- */
#define VFT2_UNKNOWN                    0x00000000L
#define VFT2_DRV_PRINTER                0x00000001L
#define VFT2_DRV_KEYBOARD               0x00000002L
#define VFT2_DRV_LANGUAGE               0x00000003L
#define VFT2_DRV_DISPLAY                0x00000004L
#define VFT2_DRV_MOUSE                  0x00000005L
#define VFT2_DRV_NETWORK                0x00000006L
#define VFT2_DRV_SYSTEM                 0x00000007L
#define VFT2_DRV_INSTALLABLE            0x00000008L
#define VFT2_DRV_SOUND                  0x00000009L
#define VFT2_DRV_COMM                   0x0000000AL

/* ----- VS_VERSION.dwFileSubtype for VFT_WINDOWS_FONT ----- */
#define VFT2_FONT_RASTER                0x00000001L
#define VFT2_FONT_VECTOR                0x00000002L
#define VFT2_FONT_TRUETYPE              0x00000003L

/* ----- VerFindFile() flags ----- */
#define VFFF_ISSHAREDFILE               0x0001

#define VFF_CURNEDEST                   0x0001
#define VFF_FILEINUSE                   0x0002
#define VFF_BUFFTOOSMALL                0x0004

/* ----- VerInstallFile() flags ----- */
#define VIFF_FORCEINSTALL               0x0001
#define VIFF_DONTDELETEOLD              0x0002

#define VIF_TEMPFILE                    0x00000001L
#define VIF_MISMATCH                    0x00000002L
#define VIF_SRCOLD                      0x00000004L

#define VIF_DIFFLANG                    0x00000008L
#define VIF_DIFFCODEPG                  0x00000010L
#define VIF_DIFFTYPE                    0x00000020L

#define VIF_WRITEPROT                   0x00000040L
#define VIF_FILEINUSE                   0x00000080L
#define VIF_OUTOFSPACE                  0x00000100L
#define VIF_ACCESSVIOLATION             0x00000200L
#define VIF_SHARINGVIOLATION            0x00000400L
#define VIF_CANNOTCREATE                0x00000800L
#define VIF_CANNOTDELETE                0x00001000L
#define VIF_CANNOTRENAME                0x00002000L
#define VIF_CANNOTDELETECUR             0x00004000L
#define VIF_OUTOFMEMORY                 0x00008000L

#define VIF_CANNOTREADSRC               0x00010000L
#define VIF_CANNOTREADDST               0x00020000L

#define VIF_BUFFTOOSMALL                0x00040000L
